function Z = desglom(J,nst,ncl,Par1,Par2,l)

%        Z = desglom(J,nst,ncl,Par1,Par2,l)
% 
% Makes design matrix for GLLM parametrization with ncl classes
%
% J    = number of lists
% nst  = numbero of stratas 
% ncl  = number of classes (2)
% name = list of the names of the parameters 
% Par1 = list of parameters GLLM the first element is the
%        strat then the class and the parameter
% Par2 = list in the new parametrization
% Z    = desgin matrix

% Probability of the second class for both the stratas
  t = 2^J-1;
  sc = nst*(ncl-1);
  mZ = nst*ncl*t+nst*(ncl-1);
  nZ = max(max(Par2))+nst*(ncl-1);
  Z = zeros(mZ,nZ); Z(1:sc,1:sc) = eye(sc);
  nP1 = size(Par1,1);
  pot = 2.^(J-1:-1:0);
  for i = 1:nP1,
    par1 = Par1(i,:); par1 = par1(find(par1));
    par2 = Par2(i,:); par2 = par2(find(par2));
    st = par1(1); cl = par1(2); par1(1:2) = [];
    row = zeros(1,J); row(par1) = ones(1,length(par1));
    row = sum(pot.*row) + (st-1)*ncl*t + (cl-1)*t + sc;
    if isempty(par2) == 0,
      Z(row,par2+sc) = ones(1,length(par2));
    end
  end
  Z(:,l+sc) = [];
% Check for identifiability
  if rank(Z) < size(Z,2),
    error('Model not identifiabile');
  end