function db = emsglom(Y,nst,ncl,J,Z,L,N,bs,rec,a,M,C)

% -      db = emsglom(Y,nst,ncl,J,Z,L,N,bs,rec,a,M,C)
% -
% - compute the variation on estimation by only one E and M step
% - using the GLMM conditional parametrization
% -
% - inputs:
% - y    : incomplete data vector (column)
% - Z    : design matrix
% - L    : L - matrix
% - bs   : starting values
% - 
% - outputs:
% - db   : variation of parameters estimation vector (column)

% - E step - ricostruisce la tabella completa

  t = 2^J-1;
  Lp = kron(eye(nst),kron(ones(1,ncl),eye(t+1))); 
  if rec == 0,
    eta = Z*bs;
    [la,pi,p,lap,pip,pp] = prob(nst,ncl,J,eta,a,M,C);    
    mu = diag(kron(sum(Y)',ones(ncl*(t+1),1)))*pp;    
    la = Lp * mu;
    la = la+10^(-8)*(la == 0);
    La = reshape(la,length(la)/nst,nst);
    Yt = kron(ones(ncl,1),Y./La);
    yt = reshape(Yt,size(Yt,1)*size(Yt,2),1);       
    mu = mu.* yt;
%    keyboard
  else
    eta = Z*bs;
    [la,pi,p,lap,pip,pp] = prob(nst,ncl,J,eta,a,M,C);    
    mu = diag(kron(sum(Y)'./(N*p),ones(ncl*(t+1),1)))*pp;    
    l = Lp * mu;
    l = l+10^(-8)*(l < 10^(-8));
    La = reshape(l,length(l)/nst,nst);
    Yt = [La(1,:); Y];
    Yt = kron ( ones(ncl,1),Yt./ La);
    yt = reshape(Yt,size(Yt,1)*size(Yt,2),1);
    mu = mu.* yt;
  end
  
% - M - step
    b = bs;
    [lk,d1,D2] = lkxglom(nst,ncl,J,Z,b,mu,a,M,C);
    it = 0; lko = -1;
    while it < 50 & abs(lko-lk) > 0.0001,
      lko = lk; it = it+1;
      b = b - inv(D2)*d1;
      b = min(max(b,-10),10);
      [lk,d1,D2] = lkxglom(nst,ncl,J,Z,b,mu,a,M,C);
    end

% - output
  db = b-bs;