% Data for capture-Recapture problem Biggeri et al. 1999
Y = [10 182 8 74 7 20 14 709 12 650 46 104 18 157 58]';

% Latent class model
Par1 = [1 1 1
        1 1 2
        1 1 3
        1 1 4
        1 2 1
        1 2 2
        1 2 3
        1 2 4];

Par2 = [1
        2
        3
        4
        5
        6
        7
        8];
     
l = [];
Z1 = desglom(4,1,2,Par1,Par2,l);
[dev1,b1,Mu1,Pco1,Pmal1,se1,Fm1] = emglom(Y,1,2,[2 2 2 2],Z1,1);
df1 = 14-size(Z1,2)
s1 = size(Fm1)
r1 = rank(Fm1)
rc1 = rcond(Fm1)

% **** Rasch Model ****
Par1 = [1 1 1
        1 1 2
        1 1 3
        1 1 4
        1 2 1
        1 2 2
        1 2 3
        1 2 4];

Par2 = [1 0
        2 0
        3 0
        4 0
        1 5
        2 5
        3 5
        4 5];
     
l = [];
Z2 = desglom(4,1,2,Par1,Par2,l);
[dev2,b2,Mu2,Pco2,Pmal2,se2,Fm2] = emglom(Y,1,2,[2 2 2 2],Z2,1);
df2 = 14-size(Z2,2)
s2 = size(Fm2)
r2 = rank(Fm2)
rc2 = rcond(Fm2)

% **** Rasch model with interactions 1-2, 1-4, 2-3 e 2-4  ****
Par1 = [1 1 1 0
        1 1 2 0
        1 1 3 0
        1 1 4 0
        1 1 1 2
        1 1 1 4
        1 1 2 3
        1 1 2 4
        1 2 1 0
        1 2 2 0
        1 2 3 0
        1 2 4 0
        1 2 1 2
        1 2 1 4
        1 2 2 3
        1 2 2 4];

Par2 = [1 0
        2 0
        3 0
        4 0
        6 0
        7 0
        8 0
        9 0
        1 5
        2 5
        3 5
        4 5
        6 0
        7 0
        8 0
        9 0];
     
l = [];
Z3 = desglom(4,1,2,Par1,Par2,l);
[dev3,b3,Mu3,Pco3,Pmal3,se3,Fm3] = emglom(Y,1,2,[2 2 2 2],Z3,1,2000,10^(-6));
df3 = 14-size(Z3,2)
s3 = size(Fm3)
r3 = rank(Fm3)
rc3 = rcond(Fm3)

