function [p,it,div] = glinv(a,A,C,eta)
%        [p,it,div] = glinv(a,A,C,eta)
% inverts the GLLM parametrization 
% eta = C*log(a+A*p)

% starting values
  [n,k]=size(A);  l0=zeros(k,1);

% prepare to iterate
  it=0; mit=100; tol=10^(-10); div=1;
  p=exp(l0); p=p./(1+sum(p));
  while (it < mit) & (div > tol),
    v = (A*p+a).^(-1);
    v = v + v*10^(-10).*(v<10^(-10));
    D=((A*p+a).^(-1))*ones(1,k);
    D=D.*A; Om=diag(p)-p*p';
    if min(A*p+a) < 0, break, end
    V = C*D*Om;
    if rcond(V)<10^(-15), V = V+eye(size(V,1))*100; end
    l=l0+inv(V)*(eta-C*log(A*p+a));
    if max(l) > 25, 
      l=(9*l0+randn(k,1))/10;
    end 
    div=sum(abs(l-l0)); l0=l;
    p=exp(l); p=p/(1+sum(p));
    it=it+1;
  end
  if div>tol, error('bad glinv'); end  