function [a,M,C] = glom(lev,mod,oc)

%        [a,M,C] = glom(lev,mod,oc)
%
% constructs ingredients for the model eta = C*log(a+M*p)
% where a+M*p are marginal distributions at all levels,
% vector lev contains the number of levels for each
% factor and contrasts refer to first category if mod = 1
% (default) and to previous category if mod = 2; oc = 'l'
% when last element of p is omitted or to 'f' for first

% preliminaries
  k=length(lev); K=sq(k); [t,k]=size(K);
  K=K(2:t,:); t=t-1; mal=max(lev)-1;
  if nargin == 1, mod=ones(1,k); oc='l'; end 
  if nargin == 2, oc='l'; end
  Cin=[-ones(mal,1) eye(mal)];  % contrasts to first
  Cad=[zeros(mal,1) eye(mal)]-[eye(mal) zeros(mal,1)];
  C=[]; A=[];

for it=1:t,
  kin=K(it,:);
  if kin(1) == 1, 
    A1=eye(lev(1)); 
    if mod(1) == 1,
      C1=Cin(1:lev(1)-1,1:lev(1));
    else 
      C1=cad(1:lev(1)-1,1:lev(1));
    end
  else 
    A1=ones(1,lev(1)); C1=1;
  end

  for ik=2:k,
    if kin(ik) == 1, 
      A2=eye(lev(ik)); 
      if mod(ik) == 1,
        C2=Cin(1:lev(ik)-1,1:lev(ik));
      else 
        C2=cad(1:lev(ik)-1,1:lev(ik));
      end
    else 
      A2=ones(1,lev(ik)); C2=1;
    end
    A1=kron(A1,A2); C1=kron(C1,C2);
  end
  [r,c]=size(C); [r1,c1]=size(C1);
  C=[C zeros(r,c1); zeros(r1,c) C1];
  A=[A;A1]; 
end
 
lp=length(A(1,:))-1;
if oc == 'l',
  a=[zeros(lp,1);1]; Iu=[eye(lp);-ones(1,lp)];
else
%  a=[1;zeros(lt,1)]; Iu=[-ones(1,lp);eye(lp)];
  a=[1;zeros(lp,1)]; Iu=[-ones(1,lp);eye(lp)];
end
a=A*a; M=A*Iu;