function [lk,gv,Fm] = lkyglom(S,C,J,Ym,Zm,bv,mv,Mm,Cm,rec)

%        [lk,gv,Fm] = lkyglom(nst,ncl,J,Y,Z,b,m,M,C)
% Computes incomplete data log-likelihood, first derivative vector
% and the information matrix 

% Preliminaries
  if rec == 0,
    t = 2^J;
    Lm = kron(eye(S),kron(ones(1,C),eye(t)));
    yv = reshape(Ym,S*t,1);
    Nm = kron(eye(S),ones(1,t));
    etav = Zm*bv;
    [lav,piv,pv,lavp,pivp,pvp,Dm,Dmp] = prob(S,C,J,etav,mv,Mm,Cm,2);
    qvp = Lm*pvp;
    rvp = Nm*qvp;   
    nvp = Nm*yv;
    t = 0;
    for i = 1:length(nvp);
      t = t + sum(log(1:nvp(i)));
    end
    for i = 1:length(yv);
      t = t - sum(log(1:yv(i)));
    end    
    lk = t + yv'*log(qvp);
    dev=2*sum(yv.*log(yv./(qvp*sum(yv))))
    % da qui  sbagliato
    gv = Zm'*Dmp'*Lm'*(inv(diag(qvp))*yv - Nm'*inv(diag(rvp))*nvp);
    ev = Nm'*inv(diag(rvp))*nvp;
    Fm = diag(qvp)^(-1)*diag(ev) - Nm'*diag(rvp)^(-2)*diag(nvp)*Nm;
    Fm = Zm' * Dmp' * Lm' * Fm * Lm * Dmp * Zm;
  else
    t = 2^J-1;
    Lm = kron(eye(S),kron(ones(1,C),eye(t)));
    yv = reshape(Ym,S*t,1);
    Nm = kron(eye(S),ones(1,t));
    etav = Zm*bv;
    [lav,piv,pv,lavp,pivp,pvp,Dm,Dmp] = prob(S,C,J,etav,mv,Mm,Cm,2);
    qv = Lm*pv;
    rv = Nm*qv;   
    nv = Nm*yv;    
    lk = yv'*log(qv) - nv'*log(rv);
    gv = Zm'*Dm'*Lm'*(inv(diag(qv))*yv - Nm'*inv(diag(rv))*nv);
    ev = Nm'*inv(diag(rv))*nv;
    Fm = diag(qv)^(-1)*diag(ev) - Nm'*diag(rv)^(-2)*diag(nv)*Nm;
    Fm = Zm' * Dm' * Lm' * Fm * Lm * Dm * Zm;
  end

% Computation of the log-likelihood first derivative and
% information matrix

